#ifndef _SINGLETON_H
#define _SINGLETON_H

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef __cplusplus
}
#endif

template <typename T> 
class Singleton
{
public:
    static T* instance()
    {
        if (m_instance == NULL) m_instance = new T;
        return m_instance;
    };

protected:
    Singleton()
	{}
    virtual ~Singleton()
	{}

private:
    Singleton(const Singleton& singleton)
	{}

    static T* m_instance;
};

template <typename T> T* Singleton<T>::m_instance = NULL;

#endif /* _SINGLETON_H */
